﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;

namespace Sample
{
    public class CustomOrthogonalConnectorTool
         : OrgLineConnectorTool
    {
        #region Class initialize/finalize methods
        /// <summary>
        /// Initializes a new instance of the <see cref="OrthogonalConnectorTool"/> class.
        /// </summary>
        /// <param name="controller">The controller.</param>
        public CustomOrthogonalConnectorTool(DiagramController controller)
            : base(controller)
        {
            this.ToolCursor = this.ActionCursor = Cursors.Cross;
        }
        #endregion

        #region Class override
        /// <summary>
        /// Creates the line shape node.
        /// </summary>
        /// <param name="ptStart">The start point.</param>
        /// <param name="ptEnd">The end point.</param>
        /// <returns>The orthogonal line connector</returns>
        protected override Node CreateNode(PointF ptStart, PointF ptEnd)
        {
           OrgLineConnector  connector1 =  base.CreateNode(ptStart, ptEnd) as OrgLineConnector;

            AddLabel(connector1, "connector", Position.Center);
            return connector1;
        }

        private static void AddLabel(Syncfusion.Windows.Forms.Diagram.PathNode rect, string labelText, Position position)
        {
            Syncfusion.Windows.Forms.Diagram.Label label = new Syncfusion.Windows.Forms.Diagram.Label(rect, labelText);
            label.Position = position;
            label.UpdatePosition = true;
            label.FontStyle.Family = "verdana";
            label.FontColorStyle.Color = Color.Black;
            label.FontStyle.Size = 9;
            rect.Labels.Add(label);
        }
        #endregion
    }
}
